/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#ifndef _MT_ABOUT_DLG_
#define _MT_ABOUT_DLG_

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	void	AddCreditLine(const char *pszLine);

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CEdit	m_wndCredits;
	CStatic	m_wndVersion;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_CREDITS, m_wndCredits);
	DDX_Control(pDX, IDC_VERSION, m_wndVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	char szVersion[25];
	sprintf(szVersion,"%.1f Build %i",MTUXVISION_VERSION,MTUXVISION_BUILD);

	m_wndVersion.SetWindowText(_T(szVersion));

	/* CREDITS */
	AddCreditLine("This is an opensource free program. Use it at your own risk\r\n");
	AddCreditLine("Author is not responsable for any damage caused by the use of this program\r\n");
	AddCreditLine("\r\nMany thanks to\r\n\r\n");
	AddCreditLine("Bernd Scharping\r\n(Tuxvision's author R.I.P.)\r\n");
	AddCreditLine("Peter Niemayer\r\n(for his Remultiplexing path)\r\n");
	AddCreditLine("Happy (the bug hunter!)\r\n");
	AddCreditLine("Hemertje & Skunny\r\n(for http://dreambox.sjerom.com and their testing time!)\r\n");
	AddCreditLine("Luca Spallared\r\n(EPG plugin and support)\r\n");
	AddCreditLine("...and...\r\n");
	AddCreditLine("everyone else who helped testing the program!\r\n");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CAboutDlg::AddCreditLine(const char *pszLine)
{
 m_wndCredits.SetSel(0,-1,TRUE);
 DWORD dwSel = m_wndCredits.GetSel();
 m_wndCredits.SetSel(HIWORD(dwSel),HIWORD(dwSel),TRUE);

 m_wndCredits.ReplaceSel(pszLine);

}

#endif //_MT_ABOUT_DLG_
