/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#include "stdafx.h"
#include "..\MTuxvision.h"
#include "DBoxComm.h"
#include <dshow.h>
#include "DShow.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CDBoxComm g_DBoxComm;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDBoxComm::CDBoxComm()
{
 Clear();
} 

CDBoxComm::~CDBoxComm()
{
 Destroy();
 Clear();
}

void CDBoxComm::Clear()
{
 m_pIDBCapture = NULL;
 m_hLastResult = NOERROR;
}

void CDBoxComm::Destroy()
{
 RELEASE(m_pIDBCapture);
}

bool CDBoxComm::Init()
{
 m_hLastResult = gpVCap->QueryInterface(IID_IDBOXIICapture, (void **)&m_pIDBCapture);
 if(FAILED(m_hLastResult))
 {
  MT_PRINT(0,"CDBoxComm::Init - Failed to obtain a IID_IDBOXIICapture interface.");
  return false;
 }

 return false;
}

char *CDBoxComm::GetAvaiableAudioPIDs()
{
 char szIP[16];
 CHttpConnection *pHttp;
 
 sprintf(szIP,"%i.%i.%i.%i",g_sGlobals.m_byDreamboxIP[0],g_sGlobals.m_byDreamboxIP[1],g_sGlobals.m_byDreamboxIP[2],g_sGlobals.m_byDreamboxIP[3]);
 
 pHttp = g_isDreambox.GetHttpConnection(_T(szIP),INTERNET_FLAG_DONT_CACHE,g_sGlobals.m_portHttp);
 if(pHttp)
 {
  DWORD dwTemp;
  char szBuff[40];

  strcpy(szBuff,"/cgi-bin/selectAudio?requester=webif");

  char *pRetInfo = NULL;

  CHttpFile *pRequest = pHttp->OpenRequest(CHttpConnection::HTTP_VERB_GET, _T(szBuff));
  try {  
	pRequest->SendRequest();
	pRequest->QueryInfoStatusCode(dwTemp);

	if(dwTemp == HTTP_STATUS_OK)
	{ // FIXME: WHAT THE FUCK! It is getting exception on SeekToEnd!
	 char szSZ[2048];
	 pRequest->ReadString(szSZ,2047);
	 DWORD dw = pRequest->GetLength();
	 /* -> Find out how big it is.
	 dwTemp = pRequest->SeekToEnd();
	 pRequest->SeekToBegin();
*/
	 // -> Copy to destination buffer
	 char *pBuff;
	 pRetInfo = new char[strlen(szSZ) + 1];

	 // -> We store newly created buffer address so we can easily read
	 // our html response piece by piece by advancing the pBuff pointer
	 // by the number of read bytes
	 strcpy(pRetInfo, szSZ);
/*
	 while(pRetInfo && (dwTemp > 0))
	 {
	  DWORD dwRead = pRequest->Read(pBuff,255);
	  
	  // Keep track of the number of read bytes
	  pBuff += dwRead;
	  dwTemp -= dwRead;
	 }*/
	}

  }catch(CInternetException *cException)
  {
	char szError[255];

	cException->GetErrorMessage(szError,255);
	MT_PRINT(0,"CDBoxComm::GetAvaiableAudioPIDs - [%i] : %s",cException->m_dwError,szError);
  }

  if(pRequest)
	  pRequest->Close();

  delete pHttp;

  return pRetInfo;
 }

 return NULL;
}

char *CDBoxComm::GetChannelInfo(/*__int64 *iAPID,__int64 *iVPID*/)
{
 char szIP[16];
 CHttpConnection *pHttp;
 
 sprintf(szIP,"%i.%i.%i.%i",g_sGlobals.m_byDreamboxIP[0],g_sGlobals.m_byDreamboxIP[1],g_sGlobals.m_byDreamboxIP[2],g_sGlobals.m_byDreamboxIP[3]);
 
 pHttp = g_isDreambox.GetHttpConnection(_T(szIP),INTERNET_FLAG_DONT_CACHE,g_sGlobals.m_portHttp);
 if(pHttp)
 {
  DWORD dwTemp;
  char szBuff[40];

  strcpy(szBuff,"/cgi-bin/streaminfo?requester=webif");

  char *pRetInfo = NULL;

  CHttpFile *pRequest = pHttp->OpenRequest(CHttpConnection::HTTP_VERB_GET, _T(szBuff));
  try {  
	pRequest->SendRequest();
	pRequest->QueryInfoStatusCode(dwTemp);

	if(dwTemp == HTTP_STATUS_OK)
	{
	 // -> Find out how big it is.
	 dwTemp = pRequest->SeekToEnd();
	 pRequest->SeekToBegin();

	 // -> Copy to destination buffer
	 char *pBuff;
	 pRetInfo = new char[dwTemp];

	 // -> We store newly created buffer address so we can easily read
	 // our html response piece by piece by advancing the pBuff pointer
	 // by the number of read bytes
	 pBuff = pRetInfo;

	 while(pRetInfo && (dwTemp > 0))
	 {
	  DWORD dwRead = pRequest->Read(pBuff,255);
	  
	  // Keep track of the number of read bytes
	  pBuff += dwRead;
	  dwTemp -= dwRead;
	 }
	}

  }catch(CInternetException *cException)
  {
	char szError[255];

	cException->GetErrorMessage(szError,255);
	MT_PRINT(0,"CDBoxComm::GetChannelInfo - [%i] : %s",cException->m_dwError,szError);
  }

  if(pRequest)
	  pRequest->Close();

  delete pHttp;

  return pRetInfo;
 }

 return NULL;
}

bool CDBoxComm::SetChannel(const char *pszChannelIDString)
{
 char szIP[16];
 CHttpConnection *pHttp;
 
 sprintf(szIP,"%i.%i.%i.%i",g_sGlobals.m_byDreamboxIP[0],g_sGlobals.m_byDreamboxIP[1],g_sGlobals.m_byDreamboxIP[2],g_sGlobals.m_byDreamboxIP[3]);
 
 pHttp = g_isDreambox.GetHttpConnection(_T(szIP),INTERNET_FLAG_DONT_CACHE,g_sGlobals.m_portHttp);
 if(pHttp)
 {
  char szCmd[255];

  sprintf(szCmd,"/cgi-bin/zapTo?path=%s",pszChannelIDString);

  CHttpFile *pRequest = pHttp->OpenRequest(CHttpConnection::HTTP_VERB_GET, _T(szCmd));

  try {  
	pRequest->SendRequest();
  }catch(CInternetException *cException)
  {
	char szError[255];

	cException->GetErrorMessage(szError,255);
	MT_PRINT(0,"CDBoxComm::SetChannel - CHttpFile exception : %s",szError);
  }

  delete pHttp;
 }

 return true;
}

bool CDBoxComm::GetResyncCountAndStatus(__int64 *iNum,__int64 *iAVStatus)
{
 m_hLastResult = m_pIDBCapture->getParameter(CMD_GETSYNCCOUNT, iNum, iAVStatus);
 if(FAILED(m_hLastResult))
	 return false;

 return true;
}

bool CDBoxComm::GetAVBitrates(__int64 *iAudio, __int64 *iVideo)
{
 m_hLastResult = m_pIDBCapture->getParameter(CMD_GETBITRATE, iAudio, iVideo);
 if(FAILED(m_hLastResult))
	 return false;

 return true;
}

bool CDBoxComm::SetAddress(const char *pszAddress)
{
 m_hLastResult = m_pIDBCapture->setParameter(CMD_IPADDRESS, (__int64)pszAddress);
 if(FAILED(m_hLastResult))
	 return false;

 return true;
}

bool CDBoxComm::SetUsername(const char *pszUser)
{
 m_hLastResult = m_pIDBCapture->setParameter(CMD_LOGIN, (__int64)pszUser);
 if(FAILED(m_hLastResult))
	 return false;

 return true;
}

bool CDBoxComm::SetPassword(const char *pszPassword)
{
 m_hLastResult = m_pIDBCapture->setParameter(CMD_PASSWORD, (__int64)pszPassword);
 if(FAILED(m_hLastResult))
	 return false;

 return true;
}
