/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#if !defined(AFX_DBOXCOMM_H__20C62CBE_6419_424B_BF27_46F374102246__INCLUDED_)
#define AFX_DBOXCOMM_H__20C62CBE_6419_424B_BF27_46F374102246__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include ".././capture/interface.h"

class CDBoxComm  
{
public:
	CDBoxComm();
	~CDBoxComm();

	void	Clear();
	bool	Init();
	void	Destroy();

	/* Functions interfaced with Enigma HTTPD*/
	bool	SetAudioPID(const char *pszPID);
	bool	SetChannel(const char *pszChannelIDString/*, __int64 apid, __int64 vpid*/);
	char    *GetAvaiableAudioPIDs();
	char	*GetChannelInfo(/*__int64 *iAPID,__int64 *iVPID*/);
	

	/* Functions interfaced with DBOXII_Capture.ax */
	bool	GetResyncCountAndStatus(__int64 *iNum,__int64 *iAVStatus);
	bool	GetAVBitrates(__int64 *iAudio, __int64 *iVideo);

	bool	SetAddress(const char *pszAddress);
	bool	SetUsername(const char *pszUser);
	bool	SetPassword(const char *pszPassword);

	HRESULT			m_hLastResult;
	IDBOXIICapture *m_pIDBCapture;
};

extern CDBoxComm g_DBoxComm;

#endif // !defined(AFX_DBOXCOMM_H__20C62CBE_6419_424B_BF27_46F374102246__INCLUDED_)
