/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#include "stdafx.h"
#include "..\mtuxvision.h"
#include "FullscreenWindow.h"
#include "..\mtuxvisiondoc.h"
#include "..\mtuxvisionview.h"

#define FULLWINDOW_CLASS_NAME "MTuxvisionFullscreen"

LRESULT CALLBACK WndProc (HWND hwnd, UINT message , WPARAM wParam, LPARAM lParam);

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFullscreenWindow::CFullscreenWindow()
{
 Clear();
}

CFullscreenWindow::~CFullscreenWindow()
{
 Destroy();
 Clear();
}

bool CFullscreenWindow::Create()
{
 WNDCLASSEX wndclassex;
 bool bRetVal = false;

 wndclassex.style			= CS_DBLCLKS;
 wndclassex.cbClsExtra		= 0;
 wndclassex.cbWndExtra		= 0;
 wndclassex.lpfnWndProc		= WndProc;
 wndclassex.hInstance		= AfxGetApp()->m_hInstance;
 wndclassex.hIcon			= NULL;
 wndclassex.hIconSm			= NULL;
 wndclassex.hCursor			= NULL;
 wndclassex.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
 wndclassex.lpszMenuName	= NULL;
 wndclassex.lpszClassName	= FULLWINDOW_CLASS_NAME;
 wndclassex.cbSize			= sizeof(wndclassex);
 
 bRetVal = RegisterClassEx(&wndclassex);
 if(!bRetVal)
	 return false;

 m_hWnd = CreateWindowEx(WS_EX_APPWINDOW, FULLWINDOW_CLASS_NAME,
			  "Fullscreen",
			  WS_POPUP,
			  0,
			  0, 
			  GetSystemMetrics(SM_CXSCREEN), 
			  GetSystemMetrics(SM_CYSCREEN),
			  NULL,
			  NULL,
			  AfxGetApp()->m_hInstance,
			  NULL);
	
 m_bAlreadySetup = bRetVal;

 return bRetVal;
}

void CFullscreenWindow::Clear()
{
 m_hWnd				= NULL;
 m_bAlreadySetup	= false;
}

void CFullscreenWindow::Destroy()
{
 DestroyWindow(m_hWnd);
 UnregisterClass(FULLWINDOW_CLASS_NAME, AfxGetApp()->m_hInstance);
}

void CFullscreenWindow::Show(bool bShow)
{
 ShowWindow(m_hWnd, bShow ? SW_SHOW : SW_HIDE);
 UpdateWindow(m_hWnd);
}

LRESULT CALLBACK WndProc (HWND hwnd, UINT message , WPARAM wParam, LPARAM lParam)
{

	switch(message)
	{
	case WM_RBUTTONUP:
		{
         MT_GetVideoView()->SendMessage(message,wParam,lParam);
		 return 0;
		}break;
	case WM_KEYDOWN:
		{
			 switch(wParam)
			 {
                case VK_ESCAPE: // Just behave like "Fullscreen" was selected in popup menu..
					{
					 WORD param_w = HIWORD(0) | LOWORD(ID_MAIN_VIDEO_FULLSCREEN);
					 MT_GetVideoView()->SendMessage(WM_COMMAND,param_w,0);
                     return(0);
					}
			 }
		}break;
	}

	return DefWindowProc(hwnd,message,wParam,lParam);
}
