/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#include "stdafx.h"
#include "..\MTuxvision.h"
#include "..\MainFrm.h"
#include "mtstatusbar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMTStatusBar

CMTStatusBar::CMTStatusBar()
{
 m_bmpDbStatus[0].LoadBitmap(IDB_OFFLINE);
 m_bmpDbStatus[1].LoadBitmap(IDB_ONLINE);
 m_bmpVolStatus[0].LoadBitmap(IDB_VOLOFF);
 m_bmpVolStatus[1].LoadBitmap(IDB_VOLON);
}

CMTStatusBar::~CMTStatusBar()
{
}


BEGIN_MESSAGE_MAP(CMTStatusBar, CStatusBar)
	//{{AFX_MSG_MAP(CMTStatusBar)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_SETTEXT, OnSetText )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMTStatusBar message handlers

void CMTStatusBar::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{	
	switch(lpDrawItemStruct->itemID)
	{
	case MT_STS_VOLCONTROL_PANE:
		{
         CDC dc;
         dc.Attach(lpDrawItemStruct->hDC);

         CRect rect(&lpDrawItemStruct->rcItem);

         CBitmap* pBitmap = (CBitmap*)&m_bmpVolStatus[(!g_sGlobals.m_byVolume) ? 0 : 1];

         CDC srcDC; // select current bitmap into a compatible CDC
         srcDC.CreateCompatibleDC(NULL);
         CBitmap* pOldBitmap = srcDC.SelectObject(pBitmap);
         dc.BitBlt(rect.left, rect.top, rect.Width(), rect.Height(),
                   &srcDC, 0, 0, SRCCOPY); // BitBlt to pane rect
         srcDC.SelectObject(pOldBitmap);

         dc.Detach();
		 return;
		}
		break;
	case MT_STS_DBSTATE_PANE:
		{
         CDC dc;
         dc.Attach(lpDrawItemStruct->hDC);

         CRect rect(&lpDrawItemStruct->rcItem);

         CBitmap* pBitmap = (CBitmap*)&m_bmpDbStatus[g_sGlobals.m_iDreamboxOnline];

         CDC srcDC; // select current bitmap into a compatible CDC
         srcDC.CreateCompatibleDC(NULL);
         CBitmap* pOldBitmap = srcDC.SelectObject(pBitmap);
         dc.BitBlt(rect.left, rect.top, rect.Width(), rect.Height(),
                   &srcDC, 0, 0, SRCCOPY); // BitBlt to pane rect
         srcDC.SelectObject(pOldBitmap);

         dc.Detach();

         return;
		}
		break;
	}
}

LRESULT CMTStatusBar::OnSetText(WPARAM wParam, LPARAM lParam)
{
 /*if ( !m_bIgnoreSetText )
    return CStatusBar::OnSetText( wParam, lParam );
*/
 return 0;  // Same as CStatusBar::OnSetText success
}


void CMTStatusBar::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CMainFrame *pMain = (CMainFrame *)MT_GetApp()->m_pMainWnd;
	if(!pMain)
		return;

	pMain->OnVolumeNotify();

	CStatusBar::OnHScroll(nSBCode, nPos, pScrollBar);
}
