/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#include "stdafx.h"
#include "..\MTuxvision.h"
#include "videoprevwnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	MT_VIDEOWND_CLASSNAME	"CVideoPrevWnd"

/////////////////////////////////////////////////////////////////////////////
// CVideoPrevWnd

CVideoPrevWnd::CVideoPrevWnd()
{
 if(!RegisterWindowClass())
	return; 
}

CVideoPrevWnd::~CVideoPrevWnd()
{
}


BEGIN_MESSAGE_MAP(CVideoPrevWnd, CWnd)
	//{{AFX_MSG_MAP(CVideoPrevWnd)
	ON_WM_ERASEBKGND()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CVideoPrevWnd::RegisterWindowClass()
{
 WNDCLASS wndcls;
 HINSTANCE hInst = AfxGetInstanceHandle();

 if(!(::GetClassInfo(hInst, MT_VIDEOWND_CLASSNAME, &wndcls)))
 {
  wndcls.style            = CS_DBLCLKS /*| CS_HREDRAW | CS_VREDRAW*/;
  wndcls.lpfnWndProc      = ::DefWindowProc;
  wndcls.cbClsExtra       = wndcls.cbWndExtra = 0;
  wndcls.hInstance        = hInst;
  wndcls.hIcon            = NULL;
  wndcls.hCursor          = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
  wndcls.hbrBackground    = (HBRUSH)GetStockObject(BLACK_BRUSH);
  wndcls.lpszMenuName     = NULL;
  wndcls.lpszClassName    = MT_VIDEOWND_CLASSNAME;

  if(!AfxRegisterClass(&wndcls))
  {
   AfxThrowResourceException();
   return FALSE;
  }
 }

 return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CVideoPrevWnd message handlers

BOOL CVideoPrevWnd::OnEraseBkgnd(CDC* pDC) 
{
 if(g_sGlobals.m_dbState > StateStopped)
	return TRUE;	// No further background erases

 return FALSE;
}

void CVideoPrevWnd::OnRButtonUp(UINT nFlags, CPoint point) 
{
	GetParent()->SendMessage(WM_RBUTTONUP, nFlags, (LOWORD(point.x) | HIWORD(point.y)));	

	CWnd::OnRButtonUp(nFlags, point);
}
