/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/

#include "stdafx.h"
#include "MTuxvision.h"
#include "Logger.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLogger::CLogger()
{
 m_pActiveMedia = NULL;
}

CLogger::~CLogger()
{
 KillActiveMedia();
}

void CLogger::KillActiveMedia()
{
 if(m_pActiveMedia)
	 delete m_pActiveMedia;

 m_pActiveMedia = NULL;
}

void CLogger::Print(int iLevel, char *szMsg, ...)
{
 if(!m_pActiveMedia)
	 return;

 char Buff[1024];

 va_list argList;

 va_start(argList,szMsg);
  vsprintf(Buff, szMsg, argList);
 va_end(argList);

 m_pActiveMedia->Output(Buff);
}

void CLogger::Flush()
{
 if(!m_pActiveMedia)
	 return;

 m_pActiveMedia->Flush();
}

void CLogger::SetMediaInterface(ITemplateMedia *pNewMedia)
{
 KillActiveMedia();

 m_pActiveMedia = pNewMedia;
}
