/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/

#if !defined(AFX_LOGGER_H__4CA550FB_F448_4E72_B264_263F9E5C6236__INCLUDED_)
#define AFX_LOGGER_H__4CA550FB_F448_4E72_B264_263F9E5C6236__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>

class ITemplateMedia
{
public:
	virtual	bool Open(const char *pszParam){return true;};
	virtual void Close(){};
	virtual void Flush(){};

	virtual void Output(char *){};
};

class ILogFile : public ITemplateMedia
{
public:
	ILogFile()
	{
	 m_hFile = 0;
	}

	~ILogFile()
	{
	 Close();
	}

	bool Open(const char *pszParam)
	{
	 m_hFile = CreateFile(pszParam,
						  GENERIC_WRITE,
						  FILE_SHARE_READ,
						  NULL,
						  CREATE_ALWAYS,
						  FILE_ATTRIBUTE_NORMAL,
						  NULL);
	 
	 if(m_hFile == INVALID_HANDLE_VALUE)
		 return false;

	 return true;
	}

	void Close()
	{
     if(m_hFile != 0)
		CloseHandle(m_hFile);
	}

	void Flush()
	{

	}

	void Output(char *szMsg)
	{
     strcat(szMsg,"\r\n");

     DWORD dwCount = strlen(szMsg);

     WriteFile( m_hFile, szMsg, dwCount, &dwCount, NULL ); 
	}

private:
	HANDLE m_hFile;
};

class CLogger  
{
public:
	CLogger();
	~CLogger();

	void	KillActiveMedia();

	void	Print(int iLevel,char *szMsg,...);
	void	Flush();

	void	SetMediaInterface(ITemplateMedia *pNewMedia);

private:
	ITemplateMedia	*m_pActiveMedia;
};

#endif // !defined(AFX_LOGGER_H__4CA550FB_F448_4E72_B264_263F9E5C6236__INCLUDED_)
