/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/

#if !defined(AFX_MTBOUQUETSVIEW_H__E497FC34_8DB5_4A4D_9B22_4314488995EA__INCLUDED_)
#define AFX_MTBOUQUETSVIEW_H__E497FC34_8DB5_4A4D_9B22_4314488995EA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MTBouquetsView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMTBouquetsView view

class CMTBouquetsView : public CTreeView
{
protected:
	CMTBouquetsView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMTBouquetsView)

// Attributes
public:
	HTREEITEM m_hUserTV;
	HTREEITEM m_hUserRadio;
	HTREEITEM m_hBouquets;

// Operations
public:
	bool LoadBouquets();
	void Traverse(HTREEITEM hParent, CBouquetNode *pParent);
	void TraverseChan(HTREEITEM hParent, CBouquetNode *pParent);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMTBouquetsView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMTBouquetsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CMTBouquetsView)
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MTBOUQUETSVIEW_H__E497FC34_8DB5_4A4D_9B22_4314488995EA__INCLUDED_)
