/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/

#include "stdafx.h"
#include "MTuxvision.h"
#include "MTSchedule.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMTSchedule

IMPLEMENT_DYNCREATE(CMTSchedule, CListView)

CMTSchedule::CMTSchedule()
{
 m_dwDefaultStyle |= (LVS_REPORT | LVS_SHOWSELALWAYS | LVS_SINGLESEL | LVS_NOSORTHEADER | LVS_NOCOLUMNHEADER);
}

CMTSchedule::~CMTSchedule()
{
}


BEGIN_MESSAGE_MAP(CMTSchedule, CListView)
	//{{AFX_MSG_MAP(CMTSchedule)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMTSchedule drawing

void CMTSchedule::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CMTSchedule diagnostics

#ifdef _DEBUG
void CMTSchedule::AssertValid() const
{
	CListView::AssertValid();
}

void CMTSchedule::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMTSchedule message handlers

void CMTSchedule::OnInitialUpdate() 
{
	CListView::OnInitialUpdate();

	ListView_SetExtendedListViewStyleEx(GetSafeHwnd(),0,LVS_EX_FULLROWSELECT);

	CListCtrl *pList = &GetListCtrl();

	pList->SetBkColor(MTUXVISION_SCHEDULE_BG);
	pList->SetTextBkColor(MTUXVISION_SCHEDULE_BG);
	
	pList->DeleteAllItems();

	// -> Setup columns
	pList->InsertColumn(0,"Time",LVCFMT_LEFT,50);
	pList->InsertColumn(1,"Program",LVCFMT_LEFT,40);
	pList->InsertColumn(2,"Channel",LVCFMT_LEFT,50);

	pList->InsertItem(0,"9.00/12.00");
	pList->SetItemText(0,1,"Pure Morning");
	pList->SetItemText(0,2,"MTV");

	pList->InsertItem(1,"12.05/12.30");
	pList->SetItemText(1,1,"Vivere");
	pList->SetItemText(1,2,"Canale 5");

	pList->InsertItem(2,"14.31/15.00");
	pList->SetItemText(2,1,"Simpsons");
	pList->SetItemText(2,2,"Italia 1");
}

void CMTSchedule::OnSize(UINT nType, int cx, int cy) 
{
	CListView::OnSize(nType, cx, cy);
	
	if(IsWindow(GetListCtrl().GetSafeHwnd()))
	{
	 GetListCtrl().SetColumnWidth(0, 70);
	 GetListCtrl().SetColumnWidth(1, cx - 110);
	 GetListCtrl().SetColumnWidth(2, 40);
	}
}
