/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#if !defined(AFX_MTUXVISION_H__A51CE250_5C60_4F1D_88EC_96C84E42C00C__INCLUDED_)
#define AFX_MTUXVISION_H__A51CE250_5C60_4F1D_88EC_96C84E42C00C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#include "Engine\BouquetsReader.h"
#include "MT_Shared.h"

/////////////////////////////////////////////////////////////////////////////
// CMTuxvisionApp:
// See MTuxvision.cpp for the implementation of this class
//

class CMTuxvisionApp : public CWinApp
{
public:
	CMTuxvisionApp();

	void LoadGlobals();
	bool SaveGlobals();

	bool GetAppPath();
	bool InitInterfaces();
	char *GetWin32ErrorMessage();	// Dont forget to free allocated memory!

	bool GetChannelInfo();			// Calls DB specific funcs to retrieve chan info

	bool StartPreview();			// Should be there or in a DX only class?
	bool StartRecord();				// Same as above..
	void StopGraph();				// Stop both preview and recording

	bool LoadLanguage(char *pszName, bool bShowConfirm = true);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMTuxvisionApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CMTuxvisionApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	HRESULT				m_hrLastResult;
	char				m_szAppPath[255];
	CBouquetsReader		m_cBouquetsReader;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MTUXVISION_H__A51CE250_5C60_4F1D_88EC_96C84E42C00C__INCLUDED_)
