/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#include "stdafx.h"
#include "MTuxvision.h"

#include "MTuxvisionDoc.h"
#include "MTuxvisionView.h"

#include "MainFrm.h"

#include <streams.h>

#include <initguid.h>

#include "Engine\dshow.h"

#define NO_SIGNAL_STRING		"No Signal"

CVideoPrevWnd *MT_GetVideoPrevWnd()
{
 CMTuxvisionView *pView = MT_GetVideoView();
 if(!pView)
	 return NULL;

 return &pView->m_wndVideoPrev;
}

CMTuxvisionView *MT_GetVideoView()
{
 CMTuxvisionView *pView = (CMTuxvisionView*)((CMainFrame*)MT_GetApp()->m_pMainWnd)->m_wndSplitter.GetPane(0,1);
 if(!pView)
	 return NULL;

 return pView;
}

/////////////////////////////////////////////////////////////////////////////
// CMTuxvisionView

IMPLEMENT_DYNCREATE(CMTuxvisionView, CFormView)

BEGIN_MESSAGE_MAP(CMTuxvisionView, CFormView)
	//{{AFX_MSG_MAP(CMTuxvisionView)
	ON_WM_CTLCOLOR()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_MAIN_VIDEO_169, OnMainVideo169)
	ON_COMMAND(ID_MAIN_VIDEO_ALWAYSONTOP, OnMainVideoAlwaysontop)
	ON_COMMAND(ID_MAIN_VIDEO_FULLSCREEN, OnMainVideoFullscreen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMTuxvisionView construction/destruction

CMTuxvisionView::CMTuxvisionView()
	: CFormView(CMTuxvisionView::IDD)
{
	//{{AFX_DATA_INIT(CMTuxvisionView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CMTuxvisionView::~CMTuxvisionView()
{
}

void CMTuxvisionView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMTuxvisionView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_VIDEOWND, m_wndVideoPrev);
}

BOOL CMTuxvisionView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CMTuxvisionView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
}

/////////////////////////////////////////////////////////////////////////////
// CMTuxvisionView diagnostics

#ifdef _DEBUG
void CMTuxvisionView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMTuxvisionView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CMTuxvisionDoc* CMTuxvisionView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMTuxvisionDoc)));
	return (CMTuxvisionDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMTuxvisionView message handlers

HBRUSH CMTuxvisionView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
    switch (nCtlColor)
    {
        case CTLCOLOR_BTN:
        case CTLCOLOR_STATIC:
        {
            pDC->SetBkMode(TRANSPARENT);
        }
        case CTLCOLOR_DLG:
        {
         return (HBRUSH) GetStockObject(BLACK_BRUSH);
        }
    }

    return(CFormView::OnCtlColor(pDC, pWnd, nCtlColor));
}

void CMTuxvisionView::OnDraw(CDC* pDC) 
{
 if(g_sGlobals.m_dbState < StatePreview)
 {
  pDC->SetBkMode(TRANSPARENT);
  COLORREF oldColor = pDC->SetTextColor(RGB(0,254,0));

  pDC->TextOut(5,5,NO_SIGNAL_STRING,strlen(NO_SIGNAL_STRING));

  pDC->SetTextColor(oldColor);		
 }else
 {
  CRect cRect;
  GetClientRect(cRect);

  pDC->FillRect(&cRect,&CBrush(RGB(0,0,0)));
 }
}

void CMTuxvisionView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	LoadViewPopup();
	
	CFormView::OnRButtonUp(nFlags, point);
}

void CMTuxvisionView::OnMainVideo169() 
{
 if(g_sGlobals.m_eVideoFormat == Format4by3)
	 g_sGlobals.m_eVideoFormat = Format16by9;
 else 
	 g_sGlobals.m_eVideoFormat = Format4by3;

 RECT rect;

 ::GetClientRect(m_wndVideoPrev.GetSafeHwnd(), &rect);
 ConnectVideoWindow(gpIGraphBuilder, m_wndVideoPrev.GetSafeHwnd(), &rect);
}

void CMTuxvisionView::OnMainVideoAlwaysontop() 
{
 if(g_sGlobals.m_bAlwaysOnTop)
	 g_sGlobals.m_bAlwaysOnTop = false;
 else
	 g_sGlobals.m_bAlwaysOnTop = true;

 ::SetWindowPos(AfxGetApp()->m_pMainWnd->GetSafeHwnd(), g_sGlobals.m_bAlwaysOnTop ? HWND_TOPMOST : HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW);	
}

void CMTuxvisionView::LoadViewPopup()
{
 CMenu menuPopup,*pMenu = NULL;

 if(!menuPopup.LoadMenu(MAKEINTRESOURCE(IDR_VIEW_MENU)))
	return;

 CPoint pt;
 GetCursorPos(&pt);
 
 pMenu = menuPopup.GetSubMenu(0);

 // -> Load current settings
 pMenu->CheckMenuItem(ID_MAIN_VIDEO_FULLSCREEN, MF_BYCOMMAND | (g_sGlobals.m_bFullscreen ? MF_CHECKED : MF_UNCHECKED));
 pMenu->CheckMenuItem(ID_MAIN_VIDEO_ALWAYSONTOP, MF_BYCOMMAND | (g_sGlobals.m_bAlwaysOnTop ? MF_CHECKED : MF_UNCHECKED));
 pMenu->CheckMenuItem(ID_MAIN_VIDEO_169,MF_BYCOMMAND | ((g_sGlobals.m_eVideoFormat == Format16by9) ? MF_CHECKED : MF_UNCHECKED));
 
 // -> Disable always on top feature if in fullscreen to prevent visualization conflicts...
 if(g_sGlobals.m_bFullscreen)
	 pMenu->EnableMenuItem(ID_MAIN_VIDEO_ALWAYSONTOP,MF_BYCOMMAND|MF_GRAYED);
 else
	 pMenu->EnableMenuItem(ID_MAIN_VIDEO_ALWAYSONTOP,MF_BYCOMMAND|MF_ENABLED);

 // -> Finally display menu
 pMenu->TrackPopupMenu(TPM_LEFTALIGN,pt.x,pt.y,this);

 menuPopup.DestroyMenu();
 
}


void CMTuxvisionView::OnMainVideoFullscreen() 
{
 CMainFrame *pMain = (CMainFrame*)MT_GetApp()->m_pMainWnd;
 if(!pMain)
	 return;

 HWND hwndTo;
 RECT rc;

 if(g_sGlobals.m_bFullscreen)
 {
  // -> Render again to MTuxvision window...	   
  pMain->m_wndFullscreen.Show(false); 	
  g_sGlobals.m_bFullscreen = false;

  // -> Restore always on top status
  if(g_sGlobals.m_bAlwaysOnTop)
	::SetWindowPos(AfxGetApp()->m_pMainWnd->GetSafeHwnd(), HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW);	

  hwndTo = m_wndVideoPrev.GetSafeHwnd();
  ::GetClientRect(hwndTo, &rc);
  ConnectVideoWindow(gpIGraphBuilder, hwndTo, &rc);

  UpdateWindow();
 }else
 {
  // -> Render to fullscreen... but first disable always on top feature (if activated)
  if(g_sGlobals.m_bAlwaysOnTop)
	::SetWindowPos(AfxGetApp()->m_pMainWnd->GetSafeHwnd(), HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW);	

  pMain->m_wndFullscreen.Show(); 	
  g_sGlobals.m_bFullscreen = true;

  hwndTo = pMain->m_wndFullscreen.GetHwnd();
  ::GetClientRect(hwndTo, &rc);
  ConnectVideoWindow(gpIGraphBuilder, hwndTo, &rc);
 }

}
