/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#include "stdafx.h"
#include "MTuxvision.h"
#include "PageGeneral.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageGeneral property page

IMPLEMENT_DYNCREATE(CPageGeneral, CPropertyPage)

CPageGeneral::CPageGeneral() : CPropertyPage(CPageGeneral::IDD)
{
	strcpy(m_szUserName,"");
	strcpy(m_szPassword,"");

	//{{AFX_DATA_INIT(CPageGeneral)
	m_uHttpPort = 0;
	m_uFtpPort = 0;
	m_bPassiveFTP = FALSE;
	m_bAlwaysOnTop = FALSE;
	m_bDBoxPreparation = FALSE;
	//}}AFX_DATA_INIT
}

CPageGeneral::~CPageGeneral()
{
}

void CPageGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageGeneral)
	DDX_Control(pDX, IDC_PRIORITY_SLIDER, m_wndPriority);
	DDX_Control(pDX, IDC_REMOTEPATH, m_wndRemotePath);
	DDX_Control(pDX, IDC_DBADDRESS, m_wndIPAddress);
	DDX_Text(pDX, IDC_HTTP_PORT, m_uHttpPort);
	DDX_Text(pDX, IDC_FTP_PORT, m_uFtpPort);
	DDX_Check(pDX, IDC_FTP_PASSIVE, m_bPassiveFTP);
	DDX_Check(pDX, IDC_ALWAYSONTOP, m_bAlwaysOnTop);
	DDX_Check(pDX, IDC_DBPREPARATION, m_bDBoxPreparation);
	//}}AFX_DATA_MAP

	DDX_Text(pDX, IDC_USERNAME, m_szUserName, 25);
	DDX_Text(pDX, IDC_PASSWORD, m_szPassword, 25);
}


BEGIN_MESSAGE_MAP(CPageGeneral, CPropertyPage)
	//{{AFX_MSG_MAP(CPageGeneral)
	ON_BN_CLICKED(IDC_DEFAULTREMOTE, OnDefaultremote)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageGeneral message handlers

BOOL CPageGeneral::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	m_wndIPAddress.SetAddress(g_sGlobals.m_byDreamboxIP[0],g_sGlobals.m_byDreamboxIP[1],
							  g_sGlobals.m_byDreamboxIP[2],g_sGlobals.m_byDreamboxIP[3]);

	strcpy(m_szUserName,g_sGlobals.m_szUsername);
	strcpy(m_szPassword,g_sGlobals.m_szPassword);

	m_bAlwaysOnTop	= g_sGlobals.m_bAlwaysOnTop;
	m_uHttpPort		= g_sGlobals.m_portHttp;
	m_uFtpPort		= g_sGlobals.m_portFtp;
	m_bPassiveFTP	= g_sGlobals.m_bPassiveFTP;

	m_wndRemotePath.SetWindowText(g_sGlobals.m_szBouquetPath);  

	m_wndPriority.SetRangeMin(0);
	m_wndPriority.SetRangeMax(2);
	m_wndPriority.SetTicFreq(1);

	UpdateData(FALSE);

	return FALSE;
}

void CPageGeneral::OnOK() 
{
	UpdateData();

	// -> Save values to registry
	m_wndIPAddress.GetAddress(g_sGlobals.m_byDreamboxIP[0],
							  g_sGlobals.m_byDreamboxIP[1],
							  g_sGlobals.m_byDreamboxIP[2],
							  g_sGlobals.m_byDreamboxIP[3]);

	strcpy(g_sGlobals.m_szUsername, m_szUserName);
	strcpy(g_sGlobals.m_szPassword, m_szPassword);

	g_sGlobals.m_bAlwaysOnTop   = m_bAlwaysOnTop;
	g_sGlobals.m_portHttp		= m_uHttpPort;
	g_sGlobals.m_portFtp		= m_uFtpPort;
	g_sGlobals.m_bPassiveFTP	= m_bPassiveFTP;

	m_wndRemotePath.GetWindowText(g_sGlobals.m_szBouquetPath, 255); 

	// Those take effect immediatly
	::SetWindowPos(AfxGetApp()->m_pMainWnd->GetSafeHwnd(), g_sGlobals.m_bAlwaysOnTop ? HWND_TOPMOST : HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW);	

	int iPos = m_wndPriority.GetPos();
	switch(iPos)
	{		
	case 0:
		SetPriorityClass(GetCurrentProcess(),NORMAL_PRIORITY_CLASS);
		break;

	case 1:
		SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS);
		break;

	case 2:
		SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS);
		break;
	}

	CPropertyPage::OnOK();
}

void CPageGeneral::OnDefaultremote() 
{
 m_wndRemotePath.SetWindowText("/var/tuxbox/config/enigma");	
}
