/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#if !defined(AFX_PARSER_H__BA21A520_9D32_4777_A760_14B5C0DD68C7__INCLUDED_)
#define AFX_PARSER_H__BA21A520_9D32_4777_A760_14B5C0DD68C7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CParser  
{
public:
	CParser();
	~CParser();

	char	*StartFile(const char *pszFileName, const char *pszTokens);
	bool	Start(const char * pBuff, const char *pszTokens);
	bool	Start(const char * pBuff, int iBuffLen, const char *pszTokens);

	char    *GetNextToken();

private:
	UINT	m_uBufferSize;		// Size of the buffer to be analyzed
	UINT	m_uNumTokens;		// Number of tokens in m_szTokens

	char    *m_pTokenStart;		// Temporary token to hold start of current token
	char	*m_pBuffer;			// Pointer to pBuff
	char    m_szTokens[255];	// Token string: each character is a separator token

	bool	IsToken(char c);
	void	Step();
};

extern CParser	g_strParser;

#endif // !defined(AFX_PARSER_H__BA21A520_9D32_4777_A760_14B5C0DD68C7__INCLUDED_)
