/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#include "stdafx.h"
#include "MTuxvision.h"
#include "pagecapture.h"
#include "MT_Utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageCapture property page

IMPLEMENT_DYNCREATE(CPageCapture, CPropertyPage)

CPageCapture::CPageCapture() : CPropertyPage(CPageCapture::IDD)
{
	//{{AFX_DATA_INIT(CPageCapture)
	m_b16by9 = FALSE;
	m_bDeinterlace = FALSE;
	//}}AFX_DATA_INIT
}

CPageCapture::~CPageCapture()
{
}

void CPageCapture::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageCapture)
	DDX_Control(pDX, IDC_EDIT2, m_wndAudioFolder);
	DDX_Control(pDX, IDC_VIDEO_FOLDER, m_wndVideoFolder);
	DDX_Check(pDX, IDC_16BY9, m_b16by9);
	DDX_Check(pDX, IDC_DEINTERLACE, m_bDeinterlace);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageCapture, CPropertyPage)
	//{{AFX_MSG_MAP(CPageCapture)
	ON_BN_CLICKED(IDC_VIDEO_BROWSE, OnVideoBrowse)
	ON_BN_CLICKED(IDC_AUDIO_BROWSE, OnAudioBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageCapture message handlers

BOOL CPageCapture::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_b16by9 = (g_sGlobals.m_eVideoFormat == Format16by9) ? TRUE : FALSE;
	m_bDeinterlace = g_sGlobals.m_bUseDeinterlacer;

	m_wndVideoFolder.SetWindowText(g_sGlobals.m_szDefaultVideoPath);
	m_wndAudioFolder.SetWindowText("Not yet implemented");

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPageCapture::OnOK() 
{
	UpdateData();

	g_sGlobals.m_eVideoFormat = (m_b16by9) ? Format16by9 : Format4by3;
	g_sGlobals.m_bUseDeinterlacer = m_bDeinterlace;

	CPropertyPage::OnOK();
}

void CPageCapture::OnVideoBrowse() 
{
 char * pszTemp = MT_ShowFolderDialog();
 if(!pszTemp)
	 return;

 strcpy(g_sGlobals.m_szDefaultVideoPath,pszTemp);
 m_wndVideoFolder.SetWindowText(pszTemp);

 delete [] pszTemp;
}

void CPageCapture::OnAudioBrowse() 
{
 AfxMessageBox("Not yet implemented");	
}
