/*
  MTuxvision - View and record channels from your Dreambox to your PC
  Copyright (C) 2007  Alessio Pierluigi Placitelli (a.placitelli@a2p.it)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
                      !!!!!! IMPORTANT !!!!!! 
  This software is based on 2004 Bernd Scharping's "tuxvision", which was
  released under the terms of GPL v2 license. Bernd "BSE" Scharping, trgically
  died in a mid-2003 car accident (http://wiki.tuxbox.org/TuxVision). Thank
  you for great software Mr. Scharping    

  ***************************************************************************
    
  File description: -
  
  Todo:
    -  
  
  Bugs:   
    -
*/


#include "stdafx.h"
#include "MTuxvision.h"
#include "preferences.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPreferences

IMPLEMENT_DYNAMIC(CPreferences, CPropertySheet)

CPreferences::CPreferences(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
 m_pPageGeneral = NULL;
 m_pPageCapture = NULL;
 m_pPageEPG		= NULL;

 m_psh.dwFlags |= PSH_NOAPPLYNOW;
}

CPreferences::CPreferences(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
 m_pPageGeneral = NULL;
 m_pPageCapture = NULL;
 m_pPageEPG		= NULL;

 m_psh.dwFlags |= PSH_NOAPPLYNOW;
}

CPreferences::~CPreferences()
{
 if(m_pPageGeneral)
	delete m_pPageGeneral;

 m_pPageGeneral = NULL;

 if(m_pPageCapture)
	delete m_pPageCapture;

 m_pPageCapture = NULL;

 if(m_pPageEPG)
	 delete m_pPageEPG;

 m_pPageEPG = NULL;
}


BEGIN_MESSAGE_MAP(CPreferences, CPropertySheet)
	//{{AFX_MSG_MAP(CPreferences)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPreferences message handlers

int CPreferences::DoModal() 
{
	if(!m_pPageGeneral)
		m_pPageGeneral = new CPageGeneral();

	if(!m_pPageCapture)
		m_pPageCapture = new CPageCapture();

	if(!m_pPageEPG)
		m_pPageEPG = new CPageEPG();

	AddPage(m_pPageGeneral);
	AddPage(m_pPageCapture);
	AddPage(m_pPageEPG);
	
	return CPropertySheet::DoModal();
}
